'
' Interface to a Microchip MCP23S17 16-bit SPI I/O peripheral
' Uses the MCP23S17 macro library routines
' For the Proton BASIC compiler version 3.5.3.0 onwards using an Amicus18 board
'
    Include "Amicus18.inc"                  ' Configure the compiler to use the 18F25K20 at 64MHz for the Amicus18 board
    Include "MCP23S17.inc"                  ' Load the MCP23S17 macros into the program

    Dim bTemp As Byte                       ' Create a variable to work with
'---------------------------------------------------------------------
' Main demonstration loop
' Mirror the input of PortA on teh outputs of PortB
' Also transmit the condition of PortA to the serial terminal
'
Main:
    MCP23S17_SetTrisPortA(%11111111)        ' Make all PortA inputs
    MCP23S17_SetTrisPortB(%00000000)        ' Make all PortB outputs
    MCP23S17_WritePortB(%00000000)          ' Pull all PortB outputs low
    MCP23S17_SetPullUpsPortA(%11111111)     ' Enable pull-up resistors on PortA

    While 1 = 1                             ' Create and infinite loop
        bTemp = MCP23S17_ReadPortA()        ' Read the condition of PortA
        HRSOut Bin8 bTemp,13                ' Transmit it to the serial terminal
        MCP23S17_WritePortB(~bTemp)         ' Place the complement of PortA on PortB       
        DelayMS 400                         ' Delay so we can see what's happening
    Wend                                    ' Close the loop
    



