'
' Interface to a Microchip MCP23S17 16-bit SPI I/O peripheral
' Uses the MCP23S17 macro library routines
' For the Proton BASIC compiler version 3.5.3.0 onwards using an Amicus18 board
'
    Include "Amicus18.inc"                  ' Configure the compiler to use the 18F25K20 at 64MHz for the Amicus18 board
    Include "MCP23S17.inc"                  ' Load the MCP23S17 macros into the program

    Dim bTemp As Byte                       ' Create a variable to work with
'---------------------------------------------------------------------
' Main demonstration loop
' Scan the outputs of the MCP23S17 from PortB.0 to PortB.7 then back
'
Main:
    MCP23S17_SetTrisPortB(%00000000)        ' Make all PortB outputs
    MCP23S17_WritePortB(%00000000)          ' Pull all PortB outputs low

    While 1 = 1                             ' Create an inifinite loop
        For bTemp = 0 To 7                  ' Form a loop from 0 to 7
            MCP23S17_WritePinPortB(bTemp,1) ' Set the bit contained in bTemp
            DelayMS 100                     ' Delay so we can see what's happening
            MCP23S17_WritePinPortB(bTemp,0) ' Clear the bit held in bTemp
        Next

        For bTemp = 6 To 1 Step -1          ' Form a loop from 6 to 1
            MCP23S17_WritePinPortB(bTemp,1) ' Set the bit held in bTemp
            DelayMS 100                     ' Delay so we can see what's happening
            MCP23S17_WritePinPortB(bTemp,0) ' Clear the bit held in bTemp
        Next
    Wend                                    ' Do it forever

